#include "I2C_BF5xx_ASM_C_API.h"

void Reset_ADV7183(void);
void Reset_ADV7179(void);


void main(void){
	unsigned short Reg3 = 0x3;
	unsigned short Reg4 = 0x4;
	unsigned short ReceivedArray[100];
	unsigned short TransmittArray[] = {0x0008, 0x0302, 0x0302, 0x0008};
	unsigned char DeviceAddress = 0x40;
	unsigned int ErrorIdent;
	// 0x40 (ADV7183A/B), 0x54 (ADV7171/ADV7179), 0xAA (KAC-9618), 0xB8 (MT9V022)
	// 0xC0 (OV6630)
	
	int i, j=0;
	Reset_ADV7183();
//	Reset_ADV7179();
	
	I2C_NonBlocked_Write(false, false, DeviceAddress, Reg3, &TransmittArray[0], 2);
	while (_SCCB_In_Progress);
	if (_SCCB_Error == 1) while(1);

	ErrorIdent = I2C_Blocked_Read(false, false, DeviceAddress, Reg3, &ReceivedArray[j++], 2);
	j++;

	ErrorIdent = I2C_Blocked_Write(false, false, DeviceAddress, Reg3, &TransmittArray[2], 2);
	
	I2C_NonBlocked_Read(false, false, DeviceAddress, Reg4, 1);
	while (_SCCB_In_Progress);
	if (_SCCB_Error == 1) while(1);
	for (i=0; i<1; i++) ReceivedArray[j++] = _SCCB_DataOut[i];

	ErrorIdent = I2C_Blocked_Read(false, false, DeviceAddress, Reg3, &ReceivedArray[j++], 1);

	I2C_NonBlocked_Write(false, false, DeviceAddress, Reg4, &TransmittArray[2], 1);
	while (_SCCB_In_Progress);
	if (_SCCB_Error == 1) while(1);
	
	I2C_NonBlocked_Read(false, false, DeviceAddress, Reg3, 2);
	while (_SCCB_In_Progress);
	if (_SCCB_Error == 1) while(1);
	for (i=0; i<2; i++) ReceivedArray[j++] = _SCCB_DataOut[i];

	I2C_NonBlocked_Write(false, false, DeviceAddress, Reg3, &TransmittArray[0], 2);
	while (_SCCB_In_Progress);
	if (_SCCB_Error == 1) while(1);

	ErrorIdent = I2C_Blocked_Read(false, false, DeviceAddress, Reg3, &ReceivedArray[j++], 2);
	j++;
while(1);
}
